# london charging stations

at fosdem 2019 talks on [linking wikidata and osm](https://fosdem.org/2019/schedule/event/geo_osmwikidata/) and using [thousands of taxi gps traces to improve osm](https://fosdem.org/2019/schedule/event/geo_gpxtraces/) gave rise to an idea to consider osm as a platform for syndicating government open data, the next step was to try and find a way to semi-automate bulk imports of open data with osm community backing

the gis team at london city hall are working to establish a re-usable means of releasing open data to osm, licensed via the [open government licence](http://www.nationalarchives.gov.uk/doc/open-government-licence/version/3/) and [compatible with the open database licence](https://wiki.openstreetmap.org/wiki/Import/ODbL_Compatibility)

### initial investigations

there were some initial queries to the [talk-gb-london group](https://lists.openstreetmap.org/pipermail/talk-gb-london/2019-March/thread.html) and the author of [osm.wikidata.link](https://osm.wikidata.link), a visit to the [london meetup](https://wiki.openstreetmap.org/wiki/London) and a visit from the [community interest company](https://osmuk.org/the-cic/) - the initial support from osm has been exemplary

#### assistance to osm
we provided geocoded ofgem environmental performance certificate data of [1314 photo voltaic installations in london](https://v.gd/london_epc_photo_voltaics)

#### first try with id and maps.me
to learn more about osm, we had a go at using [iD, the osm in-browser editor](https://overpass-turbo.eu/s/GVJ) and [a maps.me note](https://www.openstreetmap.org/node/6334516924) to map a series of 18 newly installed drinking fountains individually, and received some guidance on the use of tags in changesets

## current osm data on charging stations
https://overpass-turbo.eu/s/HKc

## details of how to maintain tags on charging stations
https://wiki.openstreetmap.org/wiki/Tag:amenity=charging_station

## gla held record
[openlayers preview](https://maps.london.gov.uk/geoserver/gis/wms?service=WMS&version=1.1.0&request=GetMap&layers=gis%3Alondon_charging_stations&bbox=-0.49845770990034466%2C51.29667980345268%2C0.2505595121779243%2C51.68268223925517&width=768&height=395&srs=EPSG%3A4326&format=application/openlayers)

## using osm conflate

### installing dependencies and running charging-stations.py

dependencies - `osm_conflate` for running checks against osm, and `requests` for getting gla data from geoserver - are managed with [Pipenv](https://pipenv.readthedocs.io) but could be done with pip and `requirements.txt`, which may be more portable to some environments

```sh
pipenv install
pipenv shell
conflate --changes preview.json --output results.osm charging-stations.py
```

after the audit has completed, you run `charging-stations.py` again with the `-a audit_charging_stations.json` parameter include the changes from validation

```sh
conflate --changes preview-audit.json --output results-audited.osm -a audit_charging_stations.json charging-stations.py
```

...or

```sh
pipenv install
pipenv run conflate --changes preview.json --output results.osm charging-stations.py
```

_note on the flags used above_
```sh
conflate --help
-c CHANGES, --changes CHANGES
                        Write changes as GeoJSON for visualization
-o OUTPUT, --output OUTPUT
                        Output OSM XML file name
```

### main details on installation and use
https://wiki.openstreetmap.org/wiki/OSM_Conflator

#### workflow to semi automate data release

the community part of the workflow is implemented in an additional project [osm-conflate-audit](https://maps.london.gov.uk/gitea/joelondon/osm-conflate-audit)

![conflation workflows](https://wiki.openstreetmap.org/w/images/f/fe/Conflate_audit_chart.jpg)

### example profile.py scripts in git repo
https://github.com/mapsme/osm_conflate/tree/master/profiles

### unfinished locations
some charging stations in this dataset are not actually installed yet, and are listed without coordinates, these are filtered out in the profile

### mapping charging stations restricted to taxis

here's a photo of a taxi-only charging station on tower bridge road:
![taxi-charging_station](./img/e-taxi-charging-station.jpg)

we received some guidance on [talk-gb-london](https://lists.openstreetmap.org/pipermail/talk-gb-london/2019-April/000184.html) on how to achieve this:

> For the stations that are restricted to taxis... would it be appropriate to use the access=* tag? It is mainly used for roads/paths and gates etc, but I think it is used in other cases to specify "who is allowed to use this feature".

> The [wiki page for access](https://wiki.openstreetmap.org/wiki/Key%3Aaccess) suggests that the way to do it would be the combination of `access=private` and `taxi=yes`
